/*
 * File:	Filters.java
 * author:	Haitao Liu (haitaol@cs.arizona.edu)
 *
 * The tauXSchema toolset, Version 1.0
 *
 * Copyright (c) 2002-2003 
 * The Department of Computer Science of the University of Arizona.
 * All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by 
 *       the Department of Computer Science of the University of Arizona."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear. 
 *
 * 4. The names "tauXSchema" or "TAU (Temporal Access for Users)" 
 *    must not be used to endorse or promote products derived from this 
 *    software without prior written permission. For written permission, 
 *    please contact tau@cs.arizona.edu.
 *
 * 5. Products derived from this software may not be called "tauXSchema",
 *    nor may "tauXSchema" or "TAU (Temporal Access for Users)" appear in 
 *    their name, without prior written permission of the Department of 
 *    Computer Science of the University of Arizona.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE Department of Computer Science of 
 * the University of Arizona OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This toolset contains useful tools to manage temporal XML document.
 * For more information about tXSchema and temporal XML document, 
 * visit the homepage of TAU Project <http://www.cs.arizona.edu/tau/>.
 */

import org.w3c.dom.*;
import org.w3c.dom.traversal.*;

import java.util.*;
import java.text.*;

class TS_TSFilterIn implements NodeFilter
{
	public short acceptNode(Node n){
		if (!(n instanceof Element))
			return NodeFilter.FILTER_REJECT;

		String name = n.getNodeName();

		if (name.equalsIgnoreCase("timestamp"))
			return NodeFilter.FILTER_ACCEPT;
		else
			return NodeFilter.FILTER_REJECT;
	}
}

class TS_TAttrFilterOut implements NodeFilter
{
	public short acceptNode(Node n){
		if (!(n instanceof Element))
			return NodeFilter.FILTER_ACCEPT;

		String name = n.getNodeName();

		if (name.equalsIgnoreCase("timestamp") || name.equalsIgnoreCase("timevarying-attr"))
			return NodeFilter.FILTER_REJECT;
		else
			return NodeFilter.FILTER_ACCEPT;
	}
}

class TS_TVAttrFilterIn implements NodeFilter
{
	public short acceptNode(Node n){
		if (!(n instanceof Element)){
			//System.out.println("reject");
			return NodeFilter.FILTER_REJECT;
		}

		String name = n.getNodeName();

		//System.out.println(name);
		if (name.equalsIgnoreCase("timevarying-attr")){
			//System.out.println("accept");
			return NodeFilter.FILTER_ACCEPT;
		}
		else{
			//System.out.println("reject");
			return NodeFilter.FILTER_REJECT;

		}
	}
}